﻿Imports System.Linq
Imports IdeaBlade.EntityModel
Imports IdeaBlade.Core.DomainServices

Imports AspAuthentication.Code
Imports IdeaBlade.EntityModel.Server
Imports IdeaBlade.Core

Namespace AspAuthentication

  ''' <summary>
  ''' Custom implementations of EntityServerQueryInterceptor and EntityServerSaveInterceptor.
  ''' Methods in these classes will be called by DevForce (on the server) during any fetch or save.
  ''' </summary>
  Public Class EntityServerQueryManager
	  Inherits EntityServerQueryInterceptor

	Protected Overrides Function FilterQuery() As Boolean

	  ' Filter the query so that the user will see only US customers unless an Admin.
	  If Not Principal.IsInRole("admin") Then
		QueryFilters.AddFilter(Of Customer)(Function(q) q.Where(Function(c) c.Country = "USA"))
		Return True
	  End If

	  Return MyBase.FilterQuery()
	End Function
  End Class

  Public Class EntityServerSaveManager
	  Inherits EntityServerSaveInterceptor

	' You can instead apply the ClientCanSave(roles) attribute on the type.  To keep it
	' simple, we do a simple role test here.  Only admins are authorized for saves.
	Protected Overrides Function ClientCanSave(ByVal type As Type) As Boolean
	  Return Principal.IsInRole("admin")
	End Function

  End Class

End Namespace